﻿<%@ Page Language="C#" AutoEventWireup="true" CodeFile="RadRotatorCoverFlowSimple.aspx.cs" Inherits="RadRotatorCoverFlowSimple" %>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
	<head runat="server">
		<title></title>
	</head>
	<body>
		<form id="form1" runat="server">
			<asp:ScriptManager ID="theScriptManager" runat="server" />
			<telerik:RadRotator ID="exampleRotator" runat="server" FrameDuration="0" ScrollDuration="2000" RotatorType="CoverFlow" Width="900" ItemWidth="300" Height="420" ItemHeight="220" WrapFrames="true">
				<ItemTemplate>
					<asp:Image ID="Image1" runat="server" ImageUrl='<%# Container.DataItem %>' AlternateText="<%# VirtualPathUtility.GetFileName(Container.DataItem.ToString()) %>" />
				</ItemTemplate>
			</telerik:RadRotator>
			<script type="text/javascript">
				//<![CDATA[
				// The set_scrollAnimationOptions method takes two arguments - the first one is the ClientID of the rotator, which we want to configure and the second one is
				// a hash table with the options we want to apply.
				Telerik.Web.UI.RadRotatorAnimation.set_scrollAnimationOptions("<%= exampleRotator.ClientID %>",
					{
						reflectionHeight: 0.5, // The height of the reflection
						reflectionOpacity: 1 // The opacity, applied to the reflection
					}
				);
				var doLoadingWait = true;
				Telerik.Web.UI.RadRotator.prototype._setImageItemsSize = function(clipRegionWidth, clipRegionHeight, startAutomaticAdvance)
				{
					$T = Telerik.Web.UI;
					$ = $telerik.$;
					var imageItemsSet = (this._imageItems.length > 0);
					var itemsElement = this._itemsElement;
					var setItemSize = (this._itemWidth && this._itemHeight);
					var isReflectionEnabled = this._toCreateReflection(clipRegionWidth, clipRegionHeight); // In case the reflection is enabled, we need to wait for all images to load.
					if((!imageItemsSet && !setItemSize) || isReflectionEnabled)
					{
						var images = $(itemsElement).find("img");
						if(!setItemSize && images.length == 0) return;

						// Check is all images are loaded in order to get their correct size.
						for(var i=0,length=images.length; i<length; i++)
						{
							var image = images[i];
							if(this._pendingImage && this._pendingImage === image && this._imageOnLoadDelegate)
							{
								$telerik.removeExternalHandler(image, "load", this._imageOnLoadDelegate);

								this._pendingImage = null;
								this._imageOnLoadDelegate = null;
								doLoadingWait = false;
							}
							else if(((image.width === undefined) || ((image.complete !== undefined) && !image.complete)) && doLoadingWait)
							{
								this._imageOnLoadDelegate = Function.createDelegate(this, function(){
									this._setImageItemsSize(clipRegionWidth, clipRegionHeight, !setItemSize);});
								$telerik.addExternalHandler(image, "load", this._imageOnLoadDelegate);
								
								this._pendingImage = image;
								
								if(!setItemSize || !startAutomaticAdvance) return;
								else break;
							}
						}
					}

					if(!imageItemsSet && startAutomaticAdvance)
					{
						this._shuffleFrames();

						// Get the original items size.
						this._setImageItems();
						if(this.isCarousel())
							this._changeCarouselAngleByIndex(this.get_initialItemIndex(), true, clipRegionWidth, clipRegionHeight);
						else
							this._changeCoverFlowIndexByIndex(this.get_initialItemIndex(), clipRegionWidth, clipRegionHeight);

						var listItems = this.getItemHtmlElements();
						$(listItems).children("div").css({
							width: "100%",
							height: "100%"}).children("img").css({
							width: "100%",
							height: "100%"});
					}
					if(!this._pendingImage)
						this._createReflection(clipRegionWidth, clipRegionHeight);

					if(!imageItemsSet && startAutomaticAdvance)
						this._startAutomaticAdvance();
				};
				//]]>
			</script>
		</form>
	</body>
</html>
